open Definitions

(** t est le type des alphabets
	; c'est un alias d'une table d'association de symboles vers des entiers *)
type t = (symbol, int) Hashtbl.t

exception Symbol_not_in_alphabet
exception Multiply_defined_symbol

let empty (): t = Hashtbl.create Common.max_symb


let add (s: symbol) (arity:int) (alpha: t): unit = 
  if Hashtbl.mem alpha s then 
    raise Multiply_defined_symbol
  else
    Hashtbl.add alpha s arity

let arity (s: symbol) (alpha: t): int =
  try
    Hashtbl.find alpha s
  with
    | Not_found -> 
        raise Symbol_not_in_alphabet

let mem s alpha =
  Hashtbl.mem alpha s

let card = Hashtbl2.length 

let to_list = Hashtbl2.elements

let to_string t = 
  Hashtbl.fold
    (fun sym ar s ->
       Symbol.to_string sym ^ ":" ^ (string_of_int ar) ^ s
    )
    t ""

    

