(* B: Yapuka documenter !!! *)
open Definitions

type substitutionset = Substitution.SubstitutionSet.t 
type substable = Substitution.SubstitutionTable.t

type condition_table = (state, Stateset.t) Hashtbl.t

type exteq =
  | Unique of (Term.term * Term.term) list
  | Equal of state * (Term.term * Term.term) list
  | Any of state * (Term.term * Term.term) list

type equation_subst  = (state, Stateset.t) Hashtbl.t
type equation_table = (state, state list) Hashtbl.t
type exteq_table = (state, exteq list) Hashtbl.t

type rule_table =
    (state, (Term.term * Rewriting.condition list) list)
      Hashtbl.t

(*
module Epsilon :
sig
  type t = state * state
  val compare : 'a -> 'a -> int
  val to_string : int * int -> string
  val equal : 'a -> 'a -> bool
end

module Epsiset : Set2.S with type elt = Epsilon.t
*)
type step = {
  alhs : Automaton.automaton;
  aeq : Automaton.automaton;
  aredex : Automaton.automaton;
	produit : Airr.airr_prod;
  svlhs : Automaton.statevar;
  sveq : Automaton.statevar;
  et : equation_table;
  eet : exteq_table;
  rt : rule_table;
  ct : condition_table;
  state2lhs : Automaton.s2t;
  state2eq : Automaton.s2t;
  pattern : Automaton.s2t;
  (* rejected : Epsiset.t; *)
  subst_for_eq : equation_subst;
  sublhs : substable;
  subeq : substable;
  new_trans : Transitions.external_symtrans list;
  new_epsi : Transitions.external_epsilon list;
}

val to_string : step -> string

val reset_step :
  step -> (* Epsiset.elt list -> *) step

val new_step :
  Automaton.automaton ->
  Rewriting.trs ->
  Equation.equational_theory ->
  Term.term list ->
  symbol list -> symbol list ->
	Automaton.automaton -> step

val fixpoint_merging :
  Transitions.external_symtrans list ->
  Transitions.external_epsilon list ->
  Automaton.automaton ->
  equation_table ->
  exteq_table ->
  Automaton.automaton ->
  Automaton.statevar ->
  equation_subst ->
  substable -> Automaton.s2t -> (* Epsiset.t -> *) Transitions.external_epsilon list

val filter_final :
  (Term.term * Stateset.elt *
   Substitution.SubstitutionSet.substitutionset)
  list ->
  (Stateset.elt * (state * Formula.t)) list ->
  Stateset.t ->
  (Term.term * state * substitutionset) list

val do_one_step :
  step ->
  step * (Term.term * state * substitutionset) list

val check_intersection :
  Automaton.automaton ->
  Term.term list ->
  symbol list ->
  (Term.term * state * substitutionset) list

val patternres_to_string :
  (Term.term * state *
     Formula.t Substitution.SubstitutionSet.Substsettemp.t)
  list -> string
