type equation =
    Regular of (Term.term * Term.term * (Term.term * Term.term) list)
  | Exteq of (Term.term * Term.term * (Term.term * Term.term) list)
  | Extany of (Term.term * Term.term * (Term.term * Term.term) list)
type equational_theory = equation list
exception InclusionTestFailed of string
exception NotHandledCondition of string
exception EquationMember of string
exception ConditionsException of Term.term * Term.term
exception ContextualEquationNotHandledYet
exception ProblemWithConditions of string
val vars : equation -> Definitions.variable list
val free_vars : equation -> Definitions.variable list
val vars_eq : equational_theory -> Definitions.variable list
val conditions_checking :
  (Term.term * Term.term) list -> Definitions.variable list -> unit
val equation_to_string : Term.term -> Term.term -> string
val to_string : equational_theory -> string
val apply : Substitution.substitution -> equation -> equation
val simplify : equation -> equation
val check : equation -> equation
val pEquation_to_equation : Global.pEquation -> equation
