type pTerm = PVar of string | PFsym of string * pTerm list | PState of string
val completeTF : bool ref
val specialState : string
exception SpecialStateDeclaration
exception SpecialStateInEpsilon
exception SpecialStateAsRHS
type pCondition =
    PEqual of (pTerm * pTerm)
  | PJoinable of (pTerm * pTerm)
  | PNotEqual of (pTerm * pTerm)
type pEquation =
    PEquation of pTerm * pTerm * pCondition list
  | PExteq of pTerm * pTerm * (pTerm * pTerm) list
  | PUnique of pTerm * (pTerm * pTerm) list
  | PAny of pTerm * pTerm * (pTerm * pTerm) list
type pRule =
    Usual of pTerm * pTerm
  | Conditionnal of pTerm * pTerm * pCondition list
type pAutomaton =
    PAut of string * pTerm list * pTerm list * (pTerm * pTerm) list *
      (pTerm * pTerm) list
  | PSet of string * pTerm list
type pApprox =
    PApp of string * pTerm list *
      ((pTerm * pTerm) * (pTerm * pTerm) list) list
  | PSEquation of string * pEquation list
type timbukspec =
    (string * pRule list) list * pAutomaton list * pTerm list * pTerm list *
    pApprox list
module PTerm :
  sig
    type t = pTerm
    val compare : 'a -> 'a -> int
    val equal : 'a -> 'a -> bool
    val to_string : pTerm -> string
  end
val alpha : (string * int) list ref
val varset : string list ref
