(* On definit le domaine comme une suite d'intervalles d'entiers possiblement disjoints *)
type t

val to_string : t -> string

val cardinal : t -> int
val is_empty : t -> bool

val make : int -> int -> t

val mem : t -> int -> bool

val add : int -> t -> unit
val remove : int -> t -> unit

val iter : (int -> unit) -> t -> unit
val fold : (int -> 'a -> 'a) -> t -> 'a -> 'a
val for_all : (int -> bool) -> t -> bool
val exists : (int -> bool) -> t -> bool

(* retourne l'entier minimum *)
val min : t -> int
val max : t -> int
(* TODO: Ne fonctionne pas avec domain vide ... *)
val l_extend : t -> int -> unit
val r_extend : t -> int -> unit
