(** Definition of verbose level: to decide when messages have to be
    displayed or tasks have to be done *)
let level = ref 0

(** We Actually use Common.verbose global reference instead of [level] *)
let println thresh str =
  if List.mem (thresh +1)!Common.verbose then print_string ("[V"^(string_of_int (thresh + 1))^"] "^str () ^ "\n")
    (* For efficiency, we use print_string instead of print_endline
       that consistently flushes the stdout *)

let print thresh str =
  if List.mem (thresh +1) !Common.verbose then print_string ("[V"^(string_of_int (thresh + 1))^"] "^str ())

let exec thresh task =
  if List.mem (thresh +1) !Common.verbose then print_string ("[V"^(string_of_int (thresh + 1))^"] ") ; task ()


let printf thresh =
  if List.mem (thresh +1) !Common.verbose then
    Format.printf
  else
    Format.ifprintf Format.std_formatter
